<template>
    <NavBar />
    <!-- GRAPH CONTENT -->
    <h1>The number of bookings per day.</h1>
    <div class="graph">
    </div>
</template>

<script>
import * as d3 from "d3"
import NavBar from "../components/NavBar"

export default {
  name: "Graph_2",
  components: {
    NavBar
  },
  data() {
    return {
      bookings: []
    }
  },
  async created() {
    // Retrieve data from vuex store
    await this.$store.dispatch('getData');
    this.bookings = this.$store.state.data

    // Render statistics graph
    await this.createGraph();
  },
  methods: {
    async createGraph() {
      // Dimensions of graph
      const margin = {top: 20, right: 30, bottom: 50, left: 40};
      const height = window.innerHeight;
      const width = window.innerWidth;

      // Append svg to div
      let svg = d3.select(".graph")
          .append("svg")
          .attr("width", width + margin.left + margin.right)
          .attr("height", height + margin.top + margin.bottom)
          .append("g")
          .attr("transform",
              "translate(" + margin.left + "," + margin.top + ")");

      // x-axis
      let x = d3.scaleTime()
          .domain(d3.extent(this.bookings, function (d) {
            return d.date;
          }))
          .range([0, width])
      svg.append("g")
          .attr("transform", "translate(0," + height + ")")
          .call(d3.axisBottom(x).tickFormat(d3.timeFormat("%d-%m-%Y")));

      // y-axis
      let y = d3.scaleLinear()
          .domain([0, d3.max(this.bookings, function (d) {
            return +d.count;
          })])
          .range([height, 0]);
      svg.append("g")
          .call(d3.axisLeft(y));

      // Draw the line
      svg.append("path")
          .datum(this.bookings)
          .attr("fill", "none")
          .attr("stroke", "steelblue")
          .attr("stroke-width", 1.5)
          .attr("d", d3.line()
              .x(function (d) {return x(d.date)})
              .y(function (d) {return y(d.count)})
          )

      // x-axis label
      svg.append("text")
          .attr("class", "x label")
          .attr("text-anchor", "end")
          .attr("x", width)
          .attr("y", height - 6)
          .text("Date");

      // y-axis label
      svg.append("text")
          .attr("class", "y label")
          .attr("text-anchor", "end")
          .attr("y", 6)
          .attr("dy", ".75em")
          .attr("transform", "rotate(-90)")
          .text("Number of Bookings");
    }
  }
}
</script>

<style scoped>
  h1 {
    display: flex;
    justify-content: center;
  }
</style>